package ejb;

import javax.ejb.SessionBean;
import javax.ejb.SessionContext;
import javax.ejb.EJBException;
import javax.naming.InitialContext;
import javax.persistence.PersistenceContext;
import javax.persistence.EntityManager;
import javax.transaction.UserTransaction;

public class Session21EJB implements SessionBean {

    @PersistenceContext(unitName="TestDataSource")
    private EntityManager em;
    private SessionContext ctx;
    private UserTransaction ut;

    private void startTransaction() {
	try {
	    ut.begin();
	} catch (Exception e) {
	    throw new EJBException(e);
	}
    }

    private void endTransaction() {
	try {
	    ut.commit();
	} catch (Exception e) {
	    throw new EJBException(e);
	}
    }

    public int doQuery() {
	startTransaction();
	try {
	    Work work = Work.findWork(em, 1);
	    return work.getStatus(); 
	} finally {
	    endTransaction();
	}
    }

    public void doUpdate() {
	startTransaction();
	try {
	    Work work = Work.findWork(em, 1);
	    work.update(); 
	} finally {
	    endTransaction();
	}
    }

    public SessionContext getSessionContext() {
	return ctx;
    }
    public void setSessionContext(SessionContext ctx) {
	this.ctx = ctx;
	try {
	    ut = (UserTransaction) new InitialContext().lookup("java:comp/UserTransaction");
	} catch (Exception e) {
	    throw new EJBException(e);
	}
    }
    public void ejbActivate() {}
    public void ejbCreate() {}
    public void ejbPassivate() {}
    public void ejbRemove() {}
}
