package web;

import ejb.*;
import javax.ejb.*;
import javax.persistence.*;

import java.io.*;

import javax.servlet.*;
import javax.servlet.http.*;
import javax.naming.*;
import javax.rmi.*;
import java.util.*;

public class TestServlet extends HttpServlet {

    Session21Home home;
    public void init(ServletConfig sc) throws ServletException {
	try {
	    InitialContext ic = new InitialContext();
	    home = (Session21Home)
		PortableRemoteObject.narrow(
		ic.lookup("java:comp/env/ejb/Session21"),
		Session21Home.class);
	} catch (Exception e) {
	    throw new ServletException(e);
	}
    }

    private static int count = 0;
    private synchronized static int getCount() {
	return count++;
    }

    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws IOException {
	String action = req.getParameter("action");
	try {
	    Session21 session = home.create();
	    if (action != null) {
		if (action.equals("update"))
		    session.doUpdate();
		else session.doQuery();
	    }
	    session.remove();
	} catch (Exception e) {
	    e.printStackTrace();
	    throw new IOException("21: " + e);
	}
	resp.setContentType("text/html");
	ServletOutputStream out = resp.getOutputStream();
	out.println("<html><body>Test done count " + getCount() + " <br>");
	out.println("<a href=\"/Test/TestServlet?action=query\">Do Query</a><br>");
	out.println("<a href=\"/Test/TestServlet?action=update\">Do Update</a><br>");
	out.println("</body></html>");
	out.close();
    }
}
